/*********************************************************************
 * Copyright 2011 Bartek thindil Jasicki
 *
 *  This file is part of Steam Fort.
 *
 *  Steam Fort is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Steam Fort is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Steam Fort.  If not, see <http://www.gnu.org/licenses/>.
*********************************************************************/
#ifndef MAIN_HPP
#define MAIN_HPP
#include <vector>
#include "mobile.hpp"
#include "item.hpp"
#include "order.hpp"
#include "building.hpp"
#include "recipe.hpp"
#include "mission.hpp"
#include "map.hpp"
#include "magic.hpp"

#define MAPWIDTH 250
#define MAPHEIGHT 250
#define SCREENWIDTH 100
#define SCREENHEIGHT 75
#define NONE -1

using namespace std;

/**
 * Contains game states (main menu, fort, etc).
 */
typedef enum GameState
  {
    MAINMENU,
    FORT,
    CREW,
    ORDERS,
    ORDER,
    BUILD,
    CONSTRUCT,
    OBJECTS,
    ABOUT,
    MOBINFO,
    ENDGAME,
    MARKS,
    MARK,
    DESIGN,
    MESSAGES,
    MOBINV,
    MISSIONS,
    ADVENTURE,
    MOBINFO2,
    MOBINV2,
    HELP,
    HELP2,
    CAST,
    CAST2,
    MTARGET,
    MTARGET2,
    USE,
    USE2
  } GAMESTATE;

/**
 * Contains objects types (mobile, item)
 */
typedef enum ObjectTypes
  {
    MOB,
    ITEM,
    BUILDING,
    ORDER1,
    DISCOVER,
    RECIPE,
    LAND,
    MISSION,
    HELPENTRY,
    SPELL
  } OBJECTTYPE;

typedef enum LandTypes
  {
    EARTH,
    LSAND,
    WATER
  } LANDTYPE;

extern vector<Item> protoobjs;
extern vector<Mobile> protomobs;
extern vector<Building> protobuilds;
extern vector<Mission> protomissions;
extern vector<Spell> protospells;
extern vector<Mobile> fortmobs;
extern vector<Item> fortobjs;
extern vector<Order> fortorders;
extern vector<Building> fortbuilds;
extern vector<Recipe> fortrecipes;
extern TCODMap *fovmap;
extern int stage;
extern TCODConsole *offconsole;
extern int screenx;
extern int screeny;
extern GameState state;
extern TCODList<int> designated[3];
extern int gtime[4];
extern Cell fortmap[MAPHEIGHT][MAPWIDTH];
extern float secs;

void draw_fort();
void game_menu();

#endif
