/*********************************************************************
 * Copyright 2011 Bartek thindil Jasicki
 *
 *  This file is part of Steam Fort.
 *
 *  Steam Fort is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Steam Fort is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Steam Fort.  If not, see <http://www.gnu.org/licenses/>.
*********************************************************************/
#ifndef MAP_HPP
#define MAP_HPP
#include "libtcod.hpp"

/**
 * Contains all data for map cell.
 */
struct Cell {
  int ch;
  TCODColor color;
  TCODColor bgcolor;
  bool walkable;
  bool transparent;
  int mob;
  TCODList<int> items;
  TCODList<int> hitems;
  int building;
  int landtype;
  float height;
  bool visited;
};

void update_map_mob(int x, int y, int mob);
void update_map_item(int x, int y, int item, bool remove = false);

#endif
