/*********************************************************************
 * Copyright 2011 Bartek thindil Jasicki
 *
 *  This file is part of Steam Fort.
 *
 *  Steam Fort is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Steam Fort is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Steam Fort.  If not, see <http://www.gnu.org/licenses/>.
*********************************************************************/
#ifndef MESSAGE_HPP
#define MESSAGE_HPP
#include <string>

/**
 * Contains all information about message.
 */
class Message
{
public:
  /**
   * Message text.
   */
  const char* text;
  /**
   * X-axis position of message
   */
  int x;
  /**
   * Y-axis position of message
   */
  int y;

  Message(std::string msg, int x1 = -1, int y1 = -1);
  void moveTo();
};

void addMessage(Message *msg);
void buildMessageUI();
void setVisibleMessage(bool visible);

#endif
